//
//  RaidEye 2.2 
//  raideye daemon
//  build 124
//  by Hany El Imam
//  copyleft 2012 hanynet.com
//
//  www.hanynet.com
//
//  NLPL license applies
//  this is open source software
//
//	monitors Mac OS X software RAID volumes (AppleRAID) and notifies failures with alert sound, email, popup message
// 
//  for Mac OS X 10.5,10.6,10.7,10.8 (ppc & i386)
//	
//	main.c


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void sleep(unsigned seconds);							//pause in seconds for the main loop
void RaidError ();										//actions to take in case of raid errors
void RaidIsOK ();										//for debug or logs
int gMailsent;											//global variable for email alert

int main (int argc, char **argv) 
{
	printf("RaidEye 2.2 daemon started. \n");	//print welcome message to stdout
	
	//read configuration file from /etc/raideyed.conf and set loop time
	//set loop time
	FILE* looptime;
	char resulttime [1000];		//shell cat|grep|cut command stdout
	looptime = popen("cat /etc/raideyed.conf |grep delayseconds |cut -d\"=\" -f2","r");
	fread(resulttime,1,sizeof(resulttime),looptime);
	int waitSeconds = atoi( resulttime );	// set loop time
	
	gMailsent = 0;
	
	// MAIN LOOP
	int i;
	for (i=1; i<100; i++) {
		i = i-1;	 //infinite loop
		
		printf("Checking RAID volumes status every %d seconds\n", waitSeconds);
		
		// check for MISSING OR DAMAGED AppleRAID volumes
		
		FILE* checkmissing;
		char resultcheckmissing [15000];	//shell diskutil command stdout
		char resultKey[] = "Missing/Damaged\n"; 
		checkmissing = popen("diskutil listraid |grep Missing | awk '{print $4}'","r"); //MacOSX 10.6
		fread(resultcheckmissing,1,sizeof(resultcheckmissing),checkmissing);
		pclose (checkmissing);
		if (strcmp(resultcheckmissing,resultKey) == 0) {
			RaidError();
		}
		if (strcmp(resultcheckmissing,resultKey) != 0) {
			RaidIsOK();
		}
		
		// check for FAILED AppleRAID volumes
		
		FILE* checkfailed;
		char resultcheckfailed [15000];	//shell diskutil command stdout
		char resultKeyb[] = "Failed\n"; 
		//check for missing or damaged AppleRAID volumes
		checkfailed = popen("diskutil listraid |grep Failed | awk '{print $4}'","r"); //MacOSX 10.6
		fread(resultcheckfailed,1,sizeof(resultcheckfailed),checkfailed);
		pclose (checkfailed);
		if (strcmp(resultcheckfailed,resultKeyb) == 0) {
			RaidError();	
		}
		if (strcmp(resultcheckfailed,resultKeyb) != 0) {
			RaidIsOK();
		}
		
		//check for errors (loop) every gWaitSeconds seconds
		sleep(waitSeconds);
	}	
	return 0; 
}


/////////////////////////////////////////////// RAID ERROR ////////////////////////////////////

//what happens if a AppleRAID error occurs
void RaidError () {
	//printf("RAID ERROR\n"); //print error to stdout
	
	int i;
	for (i=1; i<100; i++) {
		i = i-1; // infinite loop in case of error, daemon must be killed, raid must be fixed, daemon should be manually restarted.
	sleep(4); //sleep in error loop
		
		// THINGS THAT HAPPEN CONTINUOSLY (LOOP)
		
		FILE* playalertsound; //play sound
		playalertsound = popen("osascript -e 'set volume 6' ; afplay /usr/bin/raideyed.wav","r");	
		
		// THINGS THAT HAPPEN ONLY ONE TIME
		
	if (gMailsent == 0) { // do something only one time
		printf("RaidEye: RAID ERROR. An AppleRAID volume has failed. \n");	//print error to stdout
		
		FILE* raideyeapp; //finder opens raideye app (OSX10.5-10.6 only)
		raideyeapp = popen("osascript -e 'tell application \"RaidEye\" to activate'","r");
		
		printf("Sending alert email...\n");
		FILE* alertemail; //send email with python script
		alertemail = popen("python /usr/bin/raideyedemail.py","r");	
		printf("Alert email sent.\n");
		
		FILE* findermsg; //finder error message		 
		findermsg = popen("osascript -e 'tell application \"Finder\" to display dialog \"RaidEye alert: RAID ERROR! Please open RaidEye to stop audio alerts and verify RAID status.\"'","r");
		
		sleep(1);
		
		gMailsent = 1; //email has been sent.
	}
		
	}
}

/////////////////////////////////////////////// RAID OK ////////////////////////////////////

//no raid errors, everything is ok
void RaidIsOK () {
	printf("RAID volumes status: OK\n");
}






/* 
 ----------------------------------
 
 ########   RaidEye needs those files:   ######
 
 /Library/LaunchDaemons/com.hanynet.raideyed.plist file			// start daemon at boot time (644 root:wheel)
 
 /etc/raideyed.conf												// configuration file
 
 /Applications/RaidEye.app										// cocoa/applescript frontend
 
 /usr/bin/raideyed												// raideye daemon
 
 /usr/bin/raideyed.wav											// raideye alert sound
 
 /usr/bin/raideyedemail.py										// alert email python script
 
 */






